%define releasebase 3
%define nbase1 mpich2
%define modulepath /opt/Modules/modulefiles/mpi
# define AFS defines here (only used if "--with afs" is given to rpmbuild):
%define afsarch amd
%define afsroot /afs/cad/hpc

#Use as deafults if no command line inputs
%define as_limulus 1
%define use_gnu4  1
# allow --with[out] <feature> at rpm command line build
# compiler
%{?_with_gnu3: %{expand: %%define use_gnu3 1}}
%{?_with_gnu4: %{expand: %%define use_gnu4 1}}
%{?_with_pgi: %{expand: %%define use_pgi 1}}
%{?_with_intel: %{expand: %%define use_intel 1}}
%{?_with_pathsc: %{expand: %%define use_pathsc 1}}
# package tage
%{?_with_basement: %{expand: %%define as_basement 1}}
%{?_with_limulus: %{expand: %%define as_limulus 1}}
%{?_with_afs: %{expand: %%define as_afs 1}}
# OMX option
%{?_with_omx: %{expand: %%define as_omx 1}}

%if "1" == "%{as_omx}"
%define nbase %{nbase1}-omx
%else
%define nbase %{nbase1}
%endif

%define prefixbase 	/opt/mpi

#pick the target
%if "1" == "%{as_basement}"
%define _prefix   %{prefixbase}/%{fullname}
%define moduleroot      %{prefixbase}/%{name}
%define _docdir         %{_prefix}/doc
%define targetbase Basement
%else
%if "1" == "%{as_afs}"
%define _prefix %{afsroot}/%{afsarch}/%{prefixbase}/%{fullname}
%define moduleroot      %{afsroot}/%{afsarch}/%{prefixbase}/%{name}
%define  _defaultdocdir %{afsroot}/%{afsarch}/%{_usr}/share/doc
%define targetbase afs_%{afsarch}
%else
%define targetbase Limulus
%define _prefix         %{prefixbase}/%{fullname}
%define moduleroot      %{prefixbase}/%{name}
%define _docdir         %{_prefix}/doc
%endif
%endif

Summary: Argonne National Laboratory MPI implementation
Version:  1.3.2
Distribution: Scientific Linux
Vendor:  Basement Supercomputing
Packager: Douglas Eadline <deadline@basement-supercomuting.com>
License: BSD-like
Group: %{targetbase}/Libraries
Release: %{releasebase}.%{targetbase}
URL: http://www.mcs.anl.gov/mpi/mpich/
# scripts to help with SMPD use
#
# This spec file was inspired by spec files created by others for MPICH,
# including the Scyld version, written by Frederick (Rick) Niles of Scyld, and 
# included as mpich-scyld.spec in the MPICH source distribution.
#
# Spec file modified by Joe Landman for 1.2.6 with specific options
# and fixes to enable correct builds with RedHat, FCx, SuSE, ...
# placed mpich in /opt/mpich-1.2.6, and set the /etc/profile.d/mpich.*
# to point to it.a

# again modified by Joe Landman to deal with mpich2-1.0.3.
#
# Construct the source RPM with
#  mkdir ...
#  rpmbuild -ba mpich.spec ....
# This spec file requires a suitably recent version of RPM. Is there an
# RPM version tag that we should set?
#
# Modified by Douglas Eadline to work with BSC framework
#  Installs in /opt/mpi
#
# Define this to +pvfs if pvfs is available.
%define other_file_systems %{nil}

#
# These definitions are approximate.  They are taken in part from the
# mpich-scyld.spec file, though the choices here rely more on the MPICH
# configure to find the correct options for the compilers.  Not all have
# been tested (we don't have access to the Lahey compiler, for example).
%if "1" == "%{use_gnu4}"
    %define compilertag gnu4
    %define c_compiler gcc
    %define compiler_path /usr/bin
#    %define setenvs export FC=%{compiler_path}/gfortran; export F90=%{compiler_path}/gfortran
    %define setenvs export FC=%{compiler_path}/gfortran; 
    %define fopts %{nil}
    %define extralibs %{nil}
    %define extraldopts %{nil}
    %define x86_64opts CFLAGS="-fPIC" CXXFLAGS="-fPIC" FCFLAGS=" -fPIC"
%endif
%if "1" == "%{use_gnu3}"
    %define c_compiler gcc
    %define compilertag gnu3
    %define compiler_path /usr/bin
    %define setenvs export FC=%{compiler_path}/g77;
    %define fopts %{nil}
    %define extralibs %{nil}
    %define extraldopts %{nil}
    %define x86_64opts CFLAGS="-fPIC" CXXFLAGS="-fPIC" FCFLAGS=" -fPIC"
%endif
%if "1" == "%{use_intel}"
echo "INTEL Comp not implemented"
exit
    %define compilertag intel 
    %define c_compiler icc
    %define compiler_path /opt/intel/compiler50/ia32
    %define setenvs export PATH=$PATH:%{compiler_path}/bin; export LD_LIBRARY_PATH=%{compiler_path}/lib; export FC=%{compiler_path}/bin/ifc; export F90=$FC
    %define fopts -fflags="-Vaxlib "
    %define extralibs %{nil}
    %define extraldopts -L%{compiler_path}/lib -lPEPCF90 -lIEPCF90 -lF90 %{compiler_path}/lib/libintrins.a
%endif
%if "1" == "%{use_pgi}"
echo "PGI Comp not implemented"
exit
    %define compilertag pgi
    %define c_compiler pgicc
    %define compiler_path /usr/pgi/linux86
    %define setenvs export PATH=$PATH:%{compiler_path}/bin; export PGI=%{compiler_path}/..; export CC="%{compiler_path}/bin/pgcc"; export FC="/usr/pgi/linux86/bin/pgf77"; export F90="%{compiler_path}/bin/pgf90"
    %define fopts %{nil}
    %define extralibs -L%{compiler_path}/lib -lpgc
    %define extraldopts -L%{compiler_path}/lib -lpgc
%endif

Name: %{nbase}-%{compilertag}
Source0: mpich2-%{version}.tar.gz
Buildroot: %{_tmppath}/%{name}-root
Requires: modules  >= 3.2.6, libxml2
Provides: libmpich.a libfmpich.a libmpichcxx.a libmpichf90.a

%define fullname %{name}-%{version}

# Define alternate root directories for installation here

%define _mandir 	%{_prefix}/man
%define _exec_prefix  	%{_prefix}/bin
%define _bindir  	%{_prefix}/bin
%ifnarch x86_64
%define _libdir  	%{_prefix}/lib
%endif
%ifarch x86_64
%define _libdir  	%{_prefix}/lib64
%endif
%define _sbindir  	%{_prefix}/sbin
%define _includedir  	%{_prefix}/include
%define _etcdir		%{_prefix}/etc
%define _exampledir	%{_prefix}/examples


#
# If these are changed, make sure that you change the directories selected 
# under the files step.

#%define prefixdir   	%{?buildroot:%{buildroot}}%{_prefix}
#%define libdir   	%{?buildroot:%{buildroot}}%{_libdir}
%define prefixdir   	%{_prefix}
%define libdir   	%{_libdir}

# Choose whether the man pages go into a common directory or an mpich one
%define mandir   	%{?buildroot:%{buildroot}}%{_mandir}

%define exec_prefix 	%{?buildroot:%{buildroot}}%{_exec_prefix}
%define bindir 		%{?buildroot:%{buildroot}}%{_bindir}
%define sbindir 	%{?buildroot:%{buildroot}}%{_sbindir}
%define example_dir     %{?buildroot:%{buildroot}}%{_exampledir}


%description 
MPICH2 is an open-source and portable implementation of the Message-Passing
Interface (MPI, www.mpi-forum.org).  MPI is a library for parallel programming,
and is available on a wide range of parallel machines, from single laptops to
massively parallel vector parallel processors.  

%package node
Summary: MPICH2 Node Files
Group: %{targetbase}/Libraries
License: GNU
Release: %{releasebase}.%{targetbase}
Requires: modules  >= 3.2.6, libxml2

%description node
MPICH2 files needed for Perceus nodes.
To be installed in vnfs capsules.


%prep
%setup -q -n %{nbase1}-%{version}

#
# The MPICH configure is based on Autoconf version 1, and cannot be rebuilt
# with %%configure.
# These options do the following:
#   Pass the various installation directories into configure
#   Select the MPICH "device"
#   Build the shared libraries, and install them into the same directory
#   as the regular (.a) libraries
%build
%setenvs
#make installed libs available during build
export MPICH2LIB_LDFLAGS=-L%{prefixdir}/lib64
echo " MPICH2LIB_LDFLAGS"
%if "1" == "%{as_omx}"
%define omx_libs  "--with-mx-lib=/usr/open-mx/lib"
%define omx_include "--with-mx-include=/usr/open-mx/include"
%define device "--with-device=ch3:nemesis:mx"
echo "OPENMX"
%else
%define omx_libs %{nil}
%define omx_include %{nil}
%define device "--with-device=ch3:nemesis"
%endif


%ifnarch x86_64
./configure --prefix=%{prefixdir} --enable-shared \
    --enable-fast=O3  %{device} --with-hydra-bss=ssh,sge,pbs,slurm %{omx_libs} %{omx_include}
%endif
%ifarch x86_64
./configure --prefix=%{prefixdir} --enable-fast=O3 --enable-shared \
   --libdir=%{libdir}  %{device} --with-hydra-bss=ssh,sge,pbs,slurm  %{omx_libs} %{omx_include} %{x86_64opts}


%endif	
        
%{__make}
 
%install
%setenvs
if [ $RPM_BUILD_ROOT != "/" ]; then
  rm -rf $RPM_BUILD_ROOT
fi
make  DESTDIR=%{buildroot} install



# fix the uninstall path, althought this should not be used ot uninstall the package, rpm is your friend
sed 's@%{buildroot}@@g' %{buildroot}/%{prefixdir}/sbin/mpeuninstall > %{buildroot}/%{prefixdir}/sbin/mpeuninstall.1
mv %{buildroot}/%{prefixdir}/sbin/mpeuninstall.1 %{buildroot}/%{prefixdir}/sbin/mpeuninstall
# add documentation
# keep man pages with prefix, but move docs to /usr/share/doc
mkdir -p  %{buildroot}/%{prefixdir}/man
/bin/cp -a man/*  %{buildroot}/%{prefixdir}/man

# create /etc/ld.so.conf.d/
echo "Creating /etc/ld.so.conf.d/%{name} file"
mkdir -p $RPM_BUILD_ROOT/etc/ld.so.conf.d
cat <<EOF>> $RPM_BUILD_ROOT/etc/ld.so.conf.d/%{name}.conf
%{_libdir}/
EOF

%post
/sbin/ldconfig
#soft link without version number
cd %{_prefix}/..
ln -snbf %{name}-%{version} %{name}
# now make the module file
/bin/mkdir -p %{modulepath} 
cat <<EOF > %{modulepath}/%{name}
#%Module1.0#######################################################################
## mpi/mpich modulefile
##
## Copyright (c) 2008 Basement Supercomputing

conflict mpi

proc ModulesHelp { } {
        puts stderr "\tThis module loads the appropriate environment for "
        puts stderr "\tusing mpi/%{name}\n"
}

module-whatis "mpi/%{name}"
module-log error none

set currentmod \$env(HOME)/.currentmodules
set currentstring "module load mpi/%{name}"
set mpiroot %{moduleroot}

if [ module-info mode load ] {
        setenv MPIPATH \$mpiroot
        setenv MPICH2_HOME \$mpiroot
        append-path MANPATH \$mpiroot/man
        prepend-path PATH \$mpiroot/bin
        if { ! [catch {open \$currentmod {RDWR CREAT}} usermod]} {
                set all [read \$usermod]
                if { ! [ regexp \$currentstring \$all ]} {
                        puts \$usermod \$currentstring
                }
                close \$usermod
        }
}
if [ module-info mode remove ] {
        remove-path MANPATH \$mpiroot/man
        remove-path PATH \$mpiroot/bin
        unsetenv MPICH2_HOME
        unsetenv MPIPATH
        if { ! [catch {open \$currentmod r} userdel]} {
                set output ""
                foreach line [split [read \$userdel] \n] {
                        if { \$line!={} && ! [regexp [append currentstring "$"] \$line]} {
                                append output \$line "\n"
                        }
                }
                close \$userdel
        }
        if { ! [catch {open \$currentmod w} userdel]} {
                puts \$userdel \$output
                close \$userdel
        }
}
EOF
%post node
/sbin/ldconfig 2>/dev/null



%postun 
/sbin/ldconfig 2>/dev/null
/bin/rm  %{modulepath}/%{name}

%postun node
/sbin/ldconfig 2>/dev/null

%clean
if [ $RPM_BUILD_ROOT != "/" ]; then
  rm -rf $RPM_BUILD_ROOT
fi

%files
%defattr(-,root,root)
%doc README COPYRIGHT share/*
%{prefixdir}
%{_sysconfdir}/ld.so.conf.d/*

%files node
%{_sysconfdir}/ld.so.conf.d/*

%changelog
* Thu Apr 28 2011  Douglas Eadline <deadline@basement-supercomuting.com>
- clean up, made node version (just the ld.conf.d file) adjust for new version 1.3.2
* Tue Feb 13 2006  Douglas Eadline <deadline@basement-supercomuting.com>
- added examples
- made gnu{3,4}  version option
- removed -p4mpd option - did not build
- remove profile.d stuff - now use modules
- switch to spmd build so it will work with SGE
* Wed Jul 06 2005 Joe Landman <landman@scalableinformatics.com>
- fixed the AMD64 bug
* Wed Jul 06 2005 Joe Landman <landman@scalableinformatics.com>
- Update to mpich2-1.0.2 with various options.
* Fri Dec 10 2004 Joe Landman <landman@scalableinformatics.com>
- Update to mpich 1.2.6 with various options.
* Fri Jan 10 2003 Willam Gropp <gropp@mcs.anl.gov>
- Update to MPICH 1.2.5 and fixed buildroot
* Thu Apr 25 2002 William Gropp <gropp@mcs.anl.gov>
- Initial version

